#!/usr/bin/perl
use FileHandle;
use IPC::Open2;

$pastebin       = "./paste.sprunge";
$pastebin_lines = 3;
$time2run       = 11; # sec

$conf = $ARGV[0];
if(!$conf) { die "$usage"; }
do "$conf" or die "Error when doing config file";
shift;

my @signals = qw< HUP INT QUIT TERM SEGV PIPE XCPU XFSZ ALRM >;
my $signal = 'TERM';

sub signal_handler($) {
    my ($sig) = @_;
    system("printf 'system_powerdown\\nquit\\n' | nc 127.0.0.1 4444 > /dev/null 2>&1");
    $timeout = 1;
}


foreach my $sig (@signals) {
    $SIG{$sig} = \&signal_handler;
}

alarm $time2run;

open(STDERR, ">&STDOUT");
open(F, "-|", "sudo", $path_to_bot."/runqemu", $ARGV[0]) or die "internal error :(";


*OUT = *STDOUT;

$last = 0;
$split_num = 0;
for ($i = 0; <F>; $i++) {

    # print STDERR ">>>" . $_;
    last if ($last && /^ACPI: Preparing to enter system sleep state/);

    if (s/SysRq : Power Off\r\n$//) {
        last if ($_ eq "");
        $last = 1;
    }

    if ($i <= $pastebin_lines) {
        $first_lines .= $_;
    }

    if (length($_) > $max_line_size && $split_num != -1) {
        $split_num = s/.{$max_line_size}/$&\n/g;
    }

    if ($i == $pastebin_lines || ($split_num != 0 && $split_num != -1)) {
        $paste = open2(*PR, *PW, $pastebin);
        *OUT = *PW;
        print OUT $first_lines;
        $split_num = -1;
        next;
    }

    print OUT $_;
}

if ($i == 0) {
    print "no output" . (defined($timeout) ? " after $time2run sec.\n" : "\n");
}

close (F);

if(defined($paste)) {
    close (PW);
    print "etc ... " . <PR>;
    close (PR);
    waitpid($paste, 0);
}

